[BITS 32]

[GLOBAL _sort]
[GLOBAL _numbs]

[SECTION .text]
_sort:
        push    ebp
        mov     ebp, esp
        mov     ecx, [ebp + 8]         ; load array size into ECX
next_pass:
        dec     ecx                    ; if # of comparisons is zero
        jz      sort_done              ; then we are done
        mov     edi, ecx               ; else start another pass
        mov     dl, sorted             ; set status to SORTED
        mov     esi, _numbs            ; load array address into ESI
pass:
        ; ESI points to element i and ESI+4 to the next element
        ; The loop represents one pass of the algorithm.
        ; Each iteration compares elements at [ESI] and [ESI+4]
        ; and swaps them if ([ESI]) > ([ESI+4]).
        mov     eax, [esi]
        mov     ebx, [esi+4]
        cmp     eax, ebx
        jg      swap
increment:
        add     esi, 4                 ; ESI pointing to next element
        dec     edi
        jnz     pass
        cmp     edx, sorted            ; if status remains SORTED
        je      sort_done              ; then sorting is done
        jmp     next_pass              ; else initiate another pass
swap:
        ; Swap elements at [ESI] and [ESI+4]
        mov     [esi+4], eax           ; copy [ESI] in EAX to [ESI+4]
        mov     [esi], ebx             ; copy [ESI+4] in EBX to [ESI]
        mov     edx, usorted           ; set status to UNSORTED
        jmp increment
sort_done:
        mov     esp, ebp
        pop     ebp
        ret

[SECTION .data]
sorted  equ     0
usorted equ     1
max     equ     50

[SECTION .bss]
_numbs  resd    max
