[BITS 32]

[GLOBAL _docount]
[GLOBAL _dna]

[SECTION .text]
_docount:
        push    ebp
        mov     ebp, esp
        mov     ecx, [ebp + 8]         ; get sequence length from C program
        lea     esi, [_dna]            ; point to first base of sequence
next:
        mov     al, [esi]              ; get base
        cmp     al, 'A'                ; if is adenine (A)
        je      adenine                ; goto adenine increment
        cmp     al, 'C'                ; if is cytosine (C)
        je      cytosine               ; goto cytosine increment
        cmp     al, 'G'                ; if is guanine (G)
        je      guanine                ; goto guanine increment
        cmp     al, 'T'                ; if is thymine
        je      thymine                ; goto thymine increment
unknown:
        lea     edi, [counts + 16]     ; point to unknown count
        jmp     continue
adenine:
        lea     edi, [counts]          ; point to adenine count
        jmp     continue
cytosine:
        lea     edi, [counts + 4]      ; point to cytosine count
        jmp     continue
guanine:
        lea     edi, [counts + 8]      ; point to guanine count
        jmp     continue
thymine:
        lea     edi, [counts + 12]     ; point to thymine count
continue:
        mov     ebx, [edi]             ; load counter
        inc     ebx                    ; increment it
        mov     [edi], ebx             ; and restore it
        inc     esi                    ; point to next base
        dec     ecx                    ; if all bases have been counted
        jz      done                   ; we are done
        jmp     next                   ; check next base
done:
        mov     eax, counts            ; pointer to "counts" array returned to C program
        mov     esp, ebp
        pop     ebp
        ret

[SECTION .data]
max     equ     1000
counts  times   5 dd 00h

[SECTION .bss]
_dna    resb    max
