#include <stdio.h>
#include <string.h>

extern char dna[1001];
extern int * docount(int);

int main (int argc, char *argv[]) {
  FILE *fstream;
  int len, ret, done, bx, dx;
  int *ptr;
  char bases[5] = "ACGT?";
  char header[252], buffer[82];
  ret = 0;
  if (argc != 2) {
    ret = 1;
  }
  else {
    ret = 0; done = 0; dx = 0;
    fstream = fopen(argv[1], "r");
    if (fstream == NULL) {
      ret = 2;
    }
    else {
      if (fgets(header, 252, fstream)) {
        if (header[0] != '>') {
          ret = 5;
        }
        else {
          while (done == 0 && fgets(buffer, 82, fstream)) {
            bx = 0;
            if (buffer[1] == '\0') {
              done = 1;
            }
            else {
              for (int i = 1; i <= strlen(buffer); i++) {
                if (done == 0 && buffer[bx + 1] != '\0') {
                  bx++; dx++;
                  if (dx <= 1000) {
                    dna[dx - 1] = buffer[bx - 1];
                  }
                  else {
                    ret = 6; done = 1;
                  }
                }
              }
            }
          }
        }
      }
      else {
        ret = 3;
      }
    }
    if (ret == 0) {
      if (strlen(dna) < 1) {
         ret = 4;
      }
      else {
        len = strlen(dna) - 1;
        ptr = docount(len);
        dna[len] = '\0';
        header[strlen(header) - 1] = '\0';
        printf("%s\n", header);
        printf("%s\n", dna);
        printf("Base count (total = %u):\n", len);
        for (int i = 0; i < 5; i++) {
          if (i < 4 || ptr[i] > 0) {
            printf("  %c: %3u\n", bases[i], ptr[i]);
          }
        }
      }
    }
  }
  switch (ret) {
    case 1: printf("Invalid number of command line parameters\n"); break;
    case 2: printf("Error when opening file '%s'!\n", argv[1]); break;
    case 3: printf("File '%s' is empty!\n", argv[1]); break;
    case 4: printf("File '%s' doesn't contain a sequence!\n", argv[1]); break;
    case 5: printf("File '%s' is not a valid FASTA file\n", argv[1]); break;
    case 6: printf("Sequence exceeds 1000 bases!\n");
  }
  return ret;
}